# -*- coding: utf-8 -*-
from __future__ import unicode_literals

import json
import os
import xml.etree.ElementTree as ET
# Create your views here.
from collections import OrderedDict

from datetime import datetime
from django.http import HttpResponse, Http404, JsonResponse
from django.shortcuts import render
from reportlab.lib.pagesizes import letter
from reportlab.pdfgen import canvas
from django.views.decorators.csrf import csrf_exempt
from catalog.models import Purchase

# -------------------------------------------------------------------------------

########### lee archivo de configuración ################
dirname = os.path.dirname(__file__)
configfile = os.path.join(dirname, '../config/config.json')

with open(configfile, 'r') as f:
    config = json.load(f)

USERS_PATH = config['PATHS']['PATH_USERS']


###########################################################
def report_L2ASCL(request, report, purchase_id):
    path = USERS_PATH + request.user.email + '/' + purchase_id + '/'
    scl_data_path = USERS_PATH + request.user.email + "/" + purchase_id + "/" + report + ".json"


    with open(USERS_PATH + request.user.email + "/" + purchase_id + "/findProducts.json") as p:
        dataProduct = json.load(p)
        startDate = str(dataProduct['startDate'])[:4] + '-' + str(dataProduct['startDate'])[4:6] + '-' + str(
            dataProduct['startDate'])[6:8]
        endDate = str(dataProduct['endDate'])[:4] + '-' + str(dataProduct['endDate'])[4:6] + '-' + str(
            dataProduct['endDate'])[6:8]

    graphData, label, defaultLabel, defaultDataset,datasets = ProcessChartData(scl_data_path)
    #print(datasets)

    if report == 'scl_data':

        template = "sclData.html"
        reporteDir='mask'
        folders=""



        #return render(request,"sclData.html",{"graphData": json.dumps(graphData),
        #                                        "report_name": "Aqui va el mapa",
        #                                        "startDate": startDate, "endDate": endDate,
        #                                        "clouds": dataProduct['clouds'], "platform": dataProduct['platform'],
        #                                        "productLevel": dataProduct['productLevel'],'dafaultLabel': defaultLabel,
        #                                        'defaultDataSet': defaultDataset,"purchaseID": purchase_id,
        #                                        "labels": graphData['data']['labels']})
    else:

        template = "L2ASCL_data.html"

        reporteDir = report.replace('_sclData', '')

        absolute_path = USERS_PATH + request.user.email + "/" + purchase_id + "/out"
        folders = os.listdir(absolute_path)
        json_route = USERS_PATH + request.user.email + "/" + purchase_id + "/"

        for file in os.listdir(json_route):
            if file.endswith("_sclData.json") and not file.endswith("merge_out_sclData.json"):
                with open(USERS_PATH + request.user.email + "/" + purchase_id + "/" + file) as f:
                    json_data = OrderedDict(json.load(f))
                    if len(json_data) == 0:
                        if file[:6] in folders:
                            folders.remove(file[:6])

        with open(USERS_PATH + request.user.email + "/" + purchase_id + "/" + report + ".json") as f:
            json_data = OrderedDict(json.load(f))
            if len(json_data) == 0:
                graphData = ""
                defaultLabel = ""
                defaultDataset = ""
                folders.remove(reporteDir)

    image_path = request.user.email + "/" + purchase_id + "/" + "out/" + reporteDir + "/TCI/thumbnails/"
    SCL_path = request.user.email + "/" + purchase_id + "/" + "out/" + reporteDir + "/SCL/"



    #PDFGenerator(request, path, reporteDir,)



    return render(request, template, {"graphData": json.dumps(graphData),
                                                "report_name": "SCL Image Classification Data(Km²)",
                                                "startDate": startDate, "endDate": endDate,
                                                "clouds": dataProduct['clouds'], "platform": dataProduct['platform'],
                                                "productLevel": dataProduct['productLevel'], "IMAGE_PATH": image_path,
                                                "SCL_PATH": SCL_path, 'dafaultLabel': defaultLabel,
                                                'defaultDataSet': defaultDataset, "folders": folders,
                                                "zone": reporteDir, "purchaseID": purchase_id,
                                                "labels": graphData['data']['labels']})


    # -------------------------------------------------------------------------------def Reports(request):

def Reports(request):
    progress = 0
    productList = []
    size = 0
    folders = []
    zip = ""
    product_list = Purchase.objects.values('id', 'productList', 'aggreg_date', 'search__clouds', 'search__startDate',
                                           'search__endDate', 'search__process_id__name', 'search__search_name').filter(
        user_id=request.user.id, purchased=1)
    for producto in product_list:
        log_info = USERS_PATH + request.user.email + "/" + str(producto['id']) + "/L2ASCL_AreaProcessing.log"

        #####################################################
        #                progress bar                       #
        #####################################################
        if os.stat(log_info).st_size == 0:
            progress = 0
        else:
            if 'Linking Products...' in open(log_info).read():
                progress = 20
            if 'Merging Images...' in open(log_info).read():
                progress = 40
            if 'Deleting Images...' in open(log_info).read():
                progress = 50
            if 'Extracting SCL information...' in open(log_info).read():
                progress = 60
            if 'Finalizing...' in open(log_info).read():
                progress = 100
                # item = Purchase.objects.filter(pk=producto['id'])
                # item = Purchase.objects.get(pk=producto['id'])
                # item.progress = progress
                # item.save()

        with open(log_info, 'r') as myfile:
            log = myfile.read().replace('\n', '')

        for p in json.loads(producto['productList']):
            size = size + float(p['info']['size'][:-3])
            if size > 1000:
                size2 = size / 1000
                final_size = str(round(size2, 2)) + " GB"
            else:
                final_size = str(round(size, 2)) + " MB"

        initial_folder = "."
        absolute_path = USERS_PATH + request.user.email + "/" + str(producto['id']) + "/"
        if not os.path.exists(absolute_path):
            print("folder out noes not exists")
        else:
            for files in os.listdir(absolute_path):
                if files=='scl_data.json':
                    #print(files)
                    initial_folder = files[:8]
                    break
                elif files.endswith('_sclData.json'):
                    initial_folder = files[:14]
            #if len(folders) == 0:
            #    initial_folder = "../#"
            #else:
            #    initial_folder = folders.pop(0) + "_sclData"

        print(initial_folder)




        zip_path = USERS_PATH + request.user.email + "/" + str(producto['id'])
        # print(zip_path)

        # "../ static / reports / tmpImages / repsat_test_dev / umorales @ centrogeo.edu.mx / "+str(producto['id']) / myzip.zip"

        wkt = USERS_PATH + request.user.email + "/" + str(producto['id']) + "/findProducts.json"
        with open(wkt, 'r') as jsonfile:
            polygon = json.load(jsonfile)

        for file in os.listdir(zip_path):
            if file.endswith(".zip"):
                zip = zip_path + "/" + file
        productList.append({
            "search_name": producto['search__search_name'],
            "process": producto['search__process_id__name'],
            "purchase_date": producto['aggreg_date'],
            "startDate": producto['search__startDate'],
            "endDate": producto['search__endDate'],
            "clouds": producto['search__clouds'],
            "size": final_size,
            "purchase_id": producto['id'],
            "progress": progress,
            "log_info": log,
            "initial_folder": initial_folder,
            "zip": zip,
            "polygon": polygon['wkt'],
        })
        size = 0
        final_size = 0
        log_info = ""
        progress = 0
        initial_folder = ""
        zip = ""
        wkt = ""

    return render(request, 'Reports.html', {"productList": productList})


# ------------------------------------------------------------------------
def wsProcessProgress(request):
    if request.is_ajax():
        progress = 0
        productList2 = []
        product_list = Purchase.objects.values('id', 'productList', 'aggreg_date', 'search__clouds',
                                               'search__startDate', 'search__endDate',
                                               'search__process_id__name', 'progress').filter(user_id=request.user.id,
                                                                                              purchased=1)
        for producto in product_list:
            log_info = USERS_PATH + request.user.email + "/" + str(producto['id']) + "/L2ASCL_AreaProcessing.log"

            #####################################################
            #                progress bar                       #
            #####################################################
            if os.stat(log_info).st_size == 0:
                progress = 0
            else:
                if 'Linking Products...' in open(log_info).read():
                    progress = 20
                if 'Merging Images...' in open(log_info).read():
                    progress = 40
                if 'Deleting Images...' in open(log_info).read():
                    progress = 50
                if 'Extracting SCL information...' in open(log_info).read():
                    progress = 60
                if 'Finalizing...' in open(log_info).read():
                    progress = 100

            # item = Purchase.objects.get(pk=producto['id'])
            # item.progress = progress
            # item.save()

            productList2.append({
                "purchase_id": producto['id'],
                "progress": progress,
            })

            progress = 0
            log_info = ""

        # productList2 = []
        # product_list = Purchase.objects.values('id', 'progress').filter(user_id=request.user.id, purchased=1)
        # for producto in product_list:
        #     productList2.append({
        #         "purchase_id": producto['id'],
        #         "progress": producto['progress'],
        #     })
        return HttpResponse(json.dumps(productList2))
    else:
        raise Http404

# tiles
def tiles(request, purchase_id, report, date, z, x, y):
    image_path = "{}{}/{}/out/{}/TCI/tiles/{}_TCI_60m/{}/{}/{}.png".format(
        USERS_PATH, request.user.email, purchase_id, report, date, z, x, y
    )

    if not os.path.exists(image_path):
        # raise Http404
        return HttpResponse(None, content_type="image/png")

    image = open(image_path, "rb").read()
    return HttpResponse(image, content_type="image/png")


# read a xml file with tiles info to display and return that info
@csrf_exempt
def tileinfo(request):
    if request.is_ajax():
        req = dict(request.POST)

        resource_path = "{}{}/{}/out/{}/TCI/tiles/{}_TCI_60m/tilemapresource.xml".format(
            USERS_PATH, request.user.email, req['purchase_id'][0], req['report'][0],
            req['date'][0]
        )

        if not os.path.exists(resource_path):
            raise Http404

        tree = ET.parse(resource_path)
        bounding_box = tree.find('BoundingBox')
        sets = [int(set.get('order')) for set in tree.findall('TileSets/TileSet')]
        origin = tree.find('Origin')

        return JsonResponse({
            'boundingBox': [
                float(bounding_box.get('minx')),
                float(bounding_box.get('miny')),
                float(bounding_box.get('maxx')),
                float(bounding_box.get('maxy'))
            ],
            'zoom': {
                'max': int(max(sets)),
                'min': int(min(sets))
            },
            'origin': [float(origin.get('x')), float(origin.get('y'))],
            'projection': tree.find('SRS').text
        })
    else:
        raise Http404


# ------------------------------------------------------------------------
def PDFGenerator(request, ruta, reporteDir, datasets):
    thumbs = ruta + 'out/' + reporteDir + '/TCI/thumbnails/'
    SCL = ruta + 'out/' + reporteDir + '/SCL/'

    #################################################################################
    # check https://developers.google.com/chart/image/docs/making_charts            #
    # check https://developers.google.com/chart/image/docs/chart_params#gcharts_cht #
    # cht = type                                                                    #
    # chd = data values                                                             #
    # chl = labels                                                                  #
    #################################################################################

    path, dirs, files = next(os.walk(thumbs))
    w, h = letter

    c = canvas.Canvas(ruta + reporteDir + ".pdf", pagesize=letter, )

    # Header #
    c.drawImage(USERS_PATH + 'header.png', 170, h - 90, width=300, height=70)

    c.showPage()
    variable = ""
    # aqui estan los datos de todas las lineas #
    for data2 in datasets:
        # solo de la linea verde #
        print(data2['data'])
        # print(data2['data'][1])

        # variable = "0,0.0216,0,5.1408,29.8728,34.1892,57.0528,142.6788,506.6496,107.8344,0"
        variable += str(data2['data'][0])
        variable += ","
        print(variable)

    # body #
    for file in files:

        date = datetime.strptime(file[:8], '%Y%m%d').strftime('%d/%m/%Y')

        c.drawString(280, h - 125, date)

        c.drawString(160, h - 165, 'TCI')
        c.drawString(440, h - 165, 'SCL')
        c.drawImage(USERS_PATH + 'header.png', 170, h - 90, width=300, height=70)

        # Thumb image #

        c.drawImage(thumbs + file, 70, h - 470, height=300, width=200, mask='auto')

        # SCL image #
        path2, dirs2, files2 = next(os.walk(SCL))
        for file2 in files2:
            if file2.startswith(file[:8]):
                if not file2.endswith('.tif'):
                    c.drawImage(SCL + file2, 350, h - 470, height=300, width=200, mask='auto')

        # Chart #
        # los valores deben ir en chd para cada elemento #
        grafica = "https://chart.googleapis.com/chart?" \
                  "&chs=900x150" \
                  "&cht=bvs" \
                  "&chd=t:" + variable + "" \
                                         "&chds=a" \
                                         "&chco=ff8afa|659acc|99d4d9|696767|98775b|ababab|dddddd|d9f9ff|44ba5d|fff98b|383838" \
                                         "&chxt=y" \
                                         "&chm=N,000000,0,-1,11"

        c.drawImage(grafica, 140, h - 650, width=900, height=150)
        c.drawImage(USERS_PATH + 'values.png', 70, h - 680, width=500, height=25)

        c.showPage()
    c.save()
    pass
#-----------------------------------------------------------------------------------------------------------------
def ProcessChartData(path):
    with open(path) as f:
        json_data = OrderedDict(json.load(f))

        graphData = dict()
        graphData['type'] = "line"

        data = dict()
        data['labels'] = [k for k, v in sorted(json_data.items())]
        #		data['click']="chartOnClick"
        data['datasets'] = list()
        labels = set()
        for d in json_data:
            labels |= set(json_data[d].keys())
        labels.remove('date')

        labelNames = [
            "No Data", "Saturated", "Shadows", "Cloud Shadows", "Vegetation",
            "Not-Vegetated", "Water", "Unclassified", "Cloud Medium Probability",
            "Cloud High Probability", "Thin Cirrus", "Snow"
        ]

        colors = [
            "#383838", "#de3d3d", "#696767", "#98775b", "#44ba5d", "#fff98b",
            "#659acc", "#ababab", "#dddddd", "#d9f9ff", "#99d4d9", "#ff8afa"
        ]

        for l in labels:
            item = dict()
            item['label'] = labelNames[int(l)]

            # item['fill'] = "false"
            if l == "0":
                item['hidden'] = "true"
            item['data'] = [v[l] * 60 * 60 / 1000000. if (l in v) else 0 for k, v in sorted(json_data.items())]
            item['backgroundColor'] = colors[int(l)]
            data['datasets'].append(item)

        data['datasets'].sort(key=lambda k: max(k['data']))

        # PDFGenerator(request, path, reporteDir,data['datasets'])

        graphData['data'] = data
        label = graphData['data']['labels'][0]
        defaultLabel = graphData['data']['labels'][0]
        defaultDataset = label[0:4] + "/" + label[4:6] + "/" + label[6:]
    return graphData,label,defaultLabel,defaultDataset,data['datasets']
